package cn.iocoder.dashboard.modules.infra.dal.mysql.config;

import cn.iocoder.dashboard.framework.apollo.internals.ConfigFrameworkDAO;
import cn.iocoder.dashboard.modules.infra.dal.dataobject.config.InfConfigDO;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.datasource.DriverManagerDataSource;

import javax.sql.DataSource;
import java.sql.ResultSet;
import java.util.Date;
import java.util.List;

/**
 * ConfigFrameworkDAO 实现类
 *
 * @author 芋道源码
 */
public class InfConfigDAOImpl implements ConfigFrameworkDAO {

    private final JdbcTemplate jdbcTemplate;

    public InfConfigDAOImpl(String jdbcUrl, String username, String password) {
        DataSource dataSource = new DriverManagerDataSource(jdbcUrl, username, password);
        this.jdbcTemplate = new JdbcTemplate(dataSource);
    }

    @Override
    public boolean selectExistsByUpdateTimeAfter(Date maxUpdateTime) {
        return jdbcTemplate.query("SELECT id FROM inf_config WHERE update_time > ? LIMIT 1",
                ResultSet::next, maxUpdateTime);
    }

    @Override
    public List<InfConfigDO> selectList() {
        return jdbcTemplate.query("SELECT `key`, `value`, update_time, deleted FROM inf_config", new BeanPropertyRowMapper<>(InfConfigDO.class));
    }

}
